#include <iostream>
#include <fstream>
#include <sstream>
#include <string>
#include <math.h>
#include "../EasyBMP.h"

using namespace std;

struct line
{
	int coordinate_count;
	int coordinates[10][2];
	int lineheight;
};


int main(int argc, char **argv)
{
	if(argc != 2)
	{
		cout << "Usage: bmp_to_csv <bmp-file>" << endl;
		return 1;
	}
	string filename = argv[1];
	BMP img;
	img.ReadFromFile(filename.c_str());
	int width = img.TellWidth();
	int height = img.TellHeight();
	
	/*string csv_filename;
	fstream csvR;
	csv_filename = filename + "_R.csv";
	csvR.open(csv_filename.c_str(),ios::trunc | ios::out);
	fstream csvG;
	csv_filename = filename + "_G.csv";
	csvG.open(csv_filename.c_str(),ios::trunc | ios::out);
	fstream csvB;
	csv_filename = filename + "_B.csv";
	csvB.open(csv_filename.c_str(),ios::trunc | ios::out);
	
	if(csvR.is_open() && csvG.is_open() && csvB.is_open())
	{
		for(int y = 0; y < height; y++)
		{
			for(int x = 0; x< width;x++)
			{
				if(x != 0)
				{
					csvR << ";";
					csvG << ";";
					csvB << ";";
				}
				csvR << (int)img(x,y)->Red;
				csvG << (int)img(x,y)->Green;
				csvB << (int)img(x,y)->Blue;
			}
			csvR << endl;
			csvG << endl;
			csvB << endl;
		}
		csvR.close();
		csvG.close();
		csvB.close();
		cout << "Files successfully created!" << endl;
	}
	else
	{
		cout << "Could not create files" << endl;
	}*/
	
	// Gaussian blur:
	
	int blur_horisontal = 20;
	int blur_vertical = 20;
	int radius_horisontal;
	int radius_vertical;
	if(blur_horisontal%2 == 0)
	{
		radius_horisontal = (blur_horisontal)/2;
	}
	else
	{
		radius_horisontal = (blur_horisontal-1)/2;
	}
	if(blur_horisontal%2 == 0)
	{
		radius_vertical = (blur_vertical)/2;
	}
	else
	{
		radius_vertical = (blur_vertical-1)/2;
	}
	double weights_horisontal[radius_horisontal*2+1];
	for(int i = -radius_horisontal; i <= radius_horisontal;i++)
	{
		double weight = 1.0/sqrt(3.141*0.22*pow(radius_horisontal,2)) * exp( -pow(i,2)/(0.22*pow(radius_horisontal,2)) );
		weights_horisontal[i+radius_horisontal] = weight;
	}
	double weights_vertical[radius_vertical*2+1];
	for(int i = -radius_vertical; i <= radius_vertical;i++)
	{
		double weight = 1.0/sqrt(3.141*0.22*pow(radius_vertical,2)) * exp( -pow(i,2)/(0.22*pow(radius_vertical,2)) );
		weights_vertical[i+radius_vertical] = weight;
	}
	
	BMP out;
	out.SetSize(width,height);
	
	for(int y = 0; y < height; y++)
	{
		for(int x = 0; x< width;x++)
		{
			double blured_pixel = 0.;
			for(int i = -radius_horisontal; i <= radius_horisontal;i++)
			{
				double pixel;
				if(x+i < 0)
				{
					pixel = (double)(img(0,y)->Red + img(0,y)->Green + img(0,y)->Blue)/3.;
				}
				else if(x+i >= width)
				{
					pixel = (double)(img(width-1,y)->Red + img(width-1,y)->Green + img(width-1,y)->Blue)/3.;
				}
				else
				{
					pixel = (double)(img(x+i,y)->Red + img(x+i,y)->Green + img(x+i,y)->Blue)/3.;
				}
				blured_pixel += weights_horisontal[i+radius_horisontal]*(pixel+1.);
			}
			out(x,y)->Red = floor(blured_pixel);
			out(x,y)->Green = floor(blured_pixel);
			out(x,y)->Blue = floor(blured_pixel);
		}
	}
	out.WriteToFile("blured_horisontal.bmp");
	
	BMP out2;
	out2.SetSize(width,height);
	
	for(int y = 0; y < height; y++)
	{
		for(int x = 0; x< width;x++)
		{
			double blured_pixel = 0;
			for(int i = -radius_vertical; i <= radius_vertical;i++)
			{
				double pixel;
				if(y+i < 0)
				{
					pixel = (double)(out(x,0)->Red + out(x,0)->Green + out(x,0)->Blue)/3.;
				}
				else if(y+i >= height)
				{
					pixel = (double)(out(x,height-1)->Red + out(x,height-1)->Green + out(x,height-1)->Blue)/3.;
				}
				else
				{
					pixel = (double)(out(x,y+i)->Red + out(x,y+i)->Green + out(x,y+i)->Blue)/3.;
				}
				blured_pixel += weights_vertical[i+radius_vertical]*pixel;
			}
			out2(x,y)->Red = floor(blured_pixel);
			out2(x,y)->Green = floor(blured_pixel);
			out2(x,y)->Blue = floor(blured_pixel);
		}
	}
	out2.WriteToFile("blured_both.bmp");
	
	BMP difference;
	difference.SetSize(width,height);
	for(int y = 0; y < height; y++)
	{
		for(int x = 0; x< width;x++)
		{
			double avg_img_color = (double)(img(x,y)->Red + img(x,y)->Green + img(x,y)->Blue)/3.;
			double pixel = abs( avg_img_color - (double)out2(x,y)->Red );
			difference(x,y)->Red = floor(pixel);
			difference(x,y)->Green = floor(pixel);
			difference(x,y)->Blue = floor(pixel);
		}
	}
	difference.WriteToFile("difference.bmp");
	
	BMP blured_difference;
	blured_difference.SetSize(width,height);
	
	double weights_horisontal2[98+1];
	for(int i = -49; i <= 49;i++)
	{
		double weight = 1.0/sqrt(3.141*0.5*pow(49,2)) * exp( -pow(i,2)/(0.5*pow(49,2)) );
		weights_horisontal2[i+49] = weight;
		//cout << weight << endl;
	}
	for(int y = 0; y < height; y++)
	{
		for(int x = 0; x< width;x++)
		{
			double blured_pixel = 0;
			for(int i = -49; i <= 49;i++)
			{
				double pixel;
				if(x+i < 0)
				{
					pixel = (double)(difference(0,y)->Red + difference(0,y)->Green + difference(0,y)->Blue)/3.;
				}
				else if(x+i >= width)
				{
					pixel = (double)(difference(width-1,y)->Red + difference(width-1,y)->Green + difference(width-1,y)->Blue)/3.;
				}
				else
				{
					pixel = (double)(difference(x+i,y)->Red + difference(x+i,y)->Green + difference(x+i,y)->Blue)/3.;
				}
				blured_pixel += weights_horisontal2[i+49]*pixel;
			}
			blured_difference(x,y)->Red = floor(blured_pixel);
			blured_difference(x,y)->Green = floor(blured_pixel);
			blured_difference(x,y)->Blue = floor(blured_pixel);
		}
	}
	blured_difference.WriteToFile("blured_difference.bmp");


	// Lines:
	BMP lines;
	lines.SetSize(width,height);
	
	line line_array[100];
	for(int i=0;i<100;i++)
	{
		line_array[i].coordinate_count = 0;
	}
	
	for(int x = 0; x< width; x += width/10)
	{
		int line_count = 0;
		int line_start = 0;
		int line_stop = 0;
		bool last_was_line = false;
		for(int y = 0; y < height; y++)
		{
			if(blured_difference(x,y)->Red > 10)
			{
				lines(x,y)->Red = 0;
				lines(x,y)->Green = 0;
				lines(x,y)->Blue = 0;
				if(!last_was_line)
				{
					line_count++;
					line_start = y;
				}
				last_was_line = true;
			}
			else
			{
				lines(x,y)->Red = 255;
				lines(x,y)->Green = 255;
				lines(x,y)->Blue = 255;
				if(last_was_line)
				{
					line_stop = y-1;
					int linecenter = line_start + (line_stop-line_start)/2;
					cout << "Linecenter " << line_count << ": " <<  linecenter << endl;
					for(int i=0;i<100;i++)
					{
						if(line_array[i].coordinate_count == 0)
						{
							line_array[i].coordinates[0][0] = x;
							line_array[i].coordinates[0][1] = linecenter;
							line_array[i].lineheight = line_stop-line_start;
							line_array[i].coordinate_count++;
							break;
						}
						else
						{
							if(abs( (double)(line_array[i].coordinates[line_array[i].coordinate_count-1][1] - linecenter) ) < 7 )
							{
								if(line_array[i].coordinate_count < 10)
								{
									line_array[i].coordinates[line_array[i].coordinate_count][0] = x;
									line_array[i].coordinates[line_array[i].coordinate_count][1] = linecenter;
									line_array[i].coordinate_count++;
									if(line_array[i].lineheight < line_stop - line_start)
									{
										line_array[i].lineheight = line_stop - line_start;
									}
								}
								break;
							}
						}
					}
				}
				last_was_line = false;
			}
		}
		cout << "Lines: " << line_count << endl;
		
	}
	lines.WriteToFile("lines.bmp");
	
	
	
	
	for(int i=0;i<100;i++)
	{
		if(line_array[i].coordinate_count == 0)
			break;
		if(line_array[i].lineheight < 2)
			continue;
		cout << "Line " << i << ": ";
		if(i < 10)
			cout << " ";
		for(int j=0;j < line_array[i].coordinate_count ; j++)
		{
			cout << "{" << line_array[i].coordinates[j][0] << ", " << line_array[i].coordinates[j][1] << "}, ";
		}
		cout << " - Lineheight: " << line_array[i].lineheight << endl;
		
		
		// Align:
		double *centers = new double[width];
		
		for(int c=0;c < width; c++)
		{
			double slope;
			if(c <= line_array[i].coordinates[0][0])
			{
				slope = ((double)(line_array[i].coordinates[1][1]-line_array[i].coordinates[0][1])/(double)(line_array[i].coordinates[1][0]-line_array[i].coordinates[0][0]));
				centers[c] = (double)line_array[i].coordinates[0][1]+(double)(c-line_array[i].coordinates[0][0])*slope;
			}
			else if(c > line_array[i].coordinates[0][0] && c <= line_array[i].coordinates[line_array[i].coordinate_count-1][0])
			{
				int point_index = 0;
				while(point_index-1 < line_array[i].coordinate_count && line_array[i].coordinates[point_index][0] <= c )
				{
					point_index++;
				}
				if(point_index < 1)
				{
					point_index = 1;
				}
				slope = ((double)(line_array[i].coordinates[point_index][1]-line_array[i].coordinates[point_index-1][1])/(double)(line_array[i].coordinates[point_index][0]-line_array[i].coordinates[point_index-1][0]));
				centers[c] = (double)line_array[i].coordinates[point_index-1][1]+(double)(c-line_array[i].coordinates[point_index-1][0])*slope;
			}
			else
			{
				slope = ((double)(line_array[i].coordinates[line_array[i].coordinate_count-1][1]-line_array[i].coordinates[line_array[i].coordinate_count-2][1])/(double)(line_array[i].coordinates[line_array[i].coordinate_count-1][0]-line_array[i].coordinates[line_array[i].coordinate_count-2][0]));
				centers[c] = (double)line_array[i].coordinates[line_array[i].coordinate_count-1][1]+(double)(c-line_array[i].coordinates[line_array[i].coordinate_count-1][0])*slope;
			}
		}
			
		int charsize = line_array[i].lineheight + 2;
		if(charsize%2 == 1)
		{
			charsize++;
		}
		BMP out;
		out.SetSize(width,charsize);
		 
		for(int x = 0; x < width; x++)
		{
			int pixel_output = 0;
			for(int y = 0; y < height; y++)
			{
				if(abs(centers[x]-(double)y) < (double)charsize/2.0)
				{
					out(x,pixel_output)->Red = img(x,y)->Red;
					out(x,pixel_output)->Green = img(x,y)->Green;
					out(x,pixel_output)->Blue = img(x,y)->Blue;
					pixel_output++;
				}
				if(pixel_output == charsize)
				{
					break;
				}
			}
		}
		stringstream ss;
		string alignfilename;
		ss << "aligned_line" << i << ".bmp" << endl;
		ss >> alignfilename;
		out.WriteToFile(alignfilename.c_str());
		
	}
	
	
	
	
	
	return 0;
}