#include <iostream>
#include <fstream>
#include <sstream>
#include <string>
#include <math.h>
#include "EasyBMP.h"

using namespace std;

char detect_character(BMP img)
{
	double avg_img_color;
	int width = img.TellWidth();
	int height = img.TellHeight();
	
	int img_color_sum = 0;
	for(int y = 0; y < height; y++)
	{
		for(int x = 0; x < width; x++)
		{
			img_color_sum += img(x,y)->Red;
		}
	}
	avg_img_color = (double)img_color_sum/(double)(width*height);
	
	double ratio = (double)height/(double)width;
	int charclass = 0;
	
	if(ratio < 1.0)
	{
		//cout << "One of: m,w or more than one character!" << endl;
		charclass = 0;
	}
	if(ratio >= 1.0 && ratio <= 1.5)
	{
		//cout << "One of: a,c,e,g,n,o,r,s,u,v,x,z" << endl;
		charclass = 1;
	}
	if(ratio > 1.5 && ratio < 1.9)
	{
		//cout << "One of: b,d,f,g,h,k,p,q,y and almost all upper case" << endl;
		charclass = 2;
	}
	if(ratio >= 1.9)
	{
		//cout << "One of: i,j,l,t" << endl;
		charclass = 3;
	}
	
	string class1[4] = {"mw","acegnorsuvxzOQXZMW","bdfghkpqyABCDEFGHJKLNPRSTUVY","ijltI"};
	
	char alphabet[26] = {'a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q','r','s','t','u','v','w','x','y','z'};
	double max_probability = 0.;
	char most_probabable_character;
	for(int i=0;i < 26; i++)
	{
		/*bool character_in_class = false;
		for(int c0 = 0; c0 < 26; c0++)
		{
			if((char)class1[charclass][c0] == '\0')
				break;
			if((char)class1[charclass][c0] == alphabet[i])
				character_in_class = true;
		}
		if(!character_in_class)
		{
			continue;
		}*/
		stringstream ss;
		string ideal_image_path;
		ss << "../detect_character/ideal_characters/" << alphabet[i] << ".bmp";
		ss >> ideal_image_path;
		
		BMP ideal_image;
		ideal_image.ReadFromFile(ideal_image_path.c_str());
		int ideal_width = ideal_image.TellWidth();
		int ideal_height = ideal_image.TellHeight();
		double avg_ideal_color;
		
		double width_ratio = (double)ideal_width/(double)width;
		double height_ratio = (double)ideal_height/(double)height;
		
		int ideal_color_sum = 0;
		for(int y = 0; y < ideal_height; y++)
		{
			for(int x = 0; x < ideal_width; x++)
			{
				ideal_color_sum += ideal_image(x,y)->Red;
			}
		}
		avg_ideal_color = (double)ideal_color_sum/(double)(ideal_width*ideal_height);
		
		double probability = 0.;
		
		for(int y_ideal = 0; y_ideal < ideal_height; y_ideal++)
		{
			double y_img = (double)y_ideal/height_ratio;
			double bottom_weight = y_img-floor(y_img);
			double top_weight = 1.0 - bottom_weight;
			
			for(int x_ideal = 0; x_ideal < ideal_width; x_ideal++)
			{
				double x_img = (double)x_ideal/width_ratio;
				double right_weight = x_img-floor(x_img);
				double left_weight = 1.0 - right_weight;
				
				int img_color;
				if(floor(x_img) >= 0 && floor(y_img) >= 0 && floor(x_img)+1 < width && floor(y_img) < height)
				{
					img_color = (int)(left_weight*(double)(img(floor(x_img),floor(y_img))->Red) + right_weight*(double)(img(floor(x_img)+1,floor(y_img))->Red));
				}
				else
				{
					img_color = (int)( left_weight*(double)(img(floor(x_img),floor(y_img))->Red) + right_weight*255. );
				}
				int ideal_color = ideal_image(x_ideal,y_ideal)->Red;
				probability += ((double)img_color-avg_img_color)*((double)ideal_color-avg_ideal_color);
			}
		}
		probability *= 1./(double)(ideal_width*ideal_height);
		if(probability > max_probability)
		{
			max_probability = probability;
			most_probabable_character = alphabet[i];
		}
	}
	if(max_probability > 0.0)
		return most_probabable_character;
	else
		return 'l';
}

int bw_char(string filename)
{
	BMP img;
	img.ReadFromFile(filename.c_str());
	int width = img.TellWidth();
	int height = img.TellHeight();
	
	int colormap[256] = {0};


	for(int x = 0; x < width; x++)
	{
		for(int y = 0; y < height; y++)
		{
			int color = (img(x,y)->Red + img(x,y)->Green + img(x,y)->Blue)/3;
			colormap[color]++;
		}
	}
	int taerskel = 0;
	int pixel_count = 0;
	while((double)pixel_count < 0.35*(double)(width*height))
	{
		pixel_count += colormap[taerskel];
		taerskel++;
	}
	int margin_top = 0;
	int margin_right = 0;
	int margin_bottom = 0;
	int margin_left = 0;
	
	// Margin_top:
	for(int y = 0; y < height; y++)
	{
		bool white = true;
		for(int x = 0; x < width; x++)
		{
			int color = (img(x,y)->Red + img(x,y)->Green + img(x,y)->Blue)/3;
			if(color < taerskel)
			{
				white = false;
				break;
			}
		}
		if(!white)
		{
			break;
		}
		else
		{
			margin_top++;
		}
	}
	
	// Margin_right:
	for(int x = width-1; x >= 0; x--)
	{
		bool white = true;
		for(int y = 0; y < height; y++)
		{
			int color = (img(x,y)->Red + img(x,y)->Green + img(x,y)->Blue)/3;
			if(color < taerskel)
			{
				white = false;
				break;
			}
		}
		if(!white)
		{
			break;
		}
		else
		{
			margin_right++;
		}
	}
	
	// Margin_bottom:
	for(int y = height-1; y > 0; y--)
	{
		bool white = true;
		for(int x = 0; x < width; x++)
		{
			int color = (img(x,y)->Red + img(x,y)->Green + img(x,y)->Blue)/3;
			if(color < taerskel)
			{
				white = false;
				break;
			}
		}
		if(!white)
		{
			break;
		}
		else
		{
			margin_bottom++;
		}
	}
	
	// Margin_left:
	for(int x = 0; x < width; x++)
	{
		bool white = true;
		for(int y = 0; y < height; y++)
		{
			int color = (img(x,y)->Red + img(x,y)->Green + img(x,y)->Blue)/3;
			if(color < taerskel)
			{
				white = false;
				break;
			}
		}
		if(!white)
		{
			break;
		}
		else
		{
			margin_left++;
		}
	}
	
	
	BMP out;
	out.SetSize(width - (margin_left + margin_right) ,height - (margin_top+margin_bottom));
	for(int x = margin_left; x < width - margin_right; x++)
	{
		for(int y = margin_top; y < height-margin_bottom; y++)
		{
			int color = (img(x,y)->Red + img(x,y)->Green + img(x,y)->Blue)/3;
			if(color >= taerskel)
			{
				out(x-margin_left,y-margin_top)->Red = 255;
				out(x-margin_left,y-margin_top)->Green = 255;
				out(x-margin_left,y-margin_top)->Blue = 255;
			}
			else
			{
				out(x-margin_left,y-margin_top)->Red = 0;
				out(x-margin_left,y-margin_top)->Green = 0;
				out(x-margin_left,y-margin_top)->Blue = 0;
			}
		}
	}
	string outfilename = "BW" + filename;
	out.WriteToFile(outfilename.c_str());
	
	char response = detect_character(out);
	cout << response;
	
	return 0;
}

int main(int argc, char **argv)
{
	if(argc != 2)
	{
		cout << "Usage: align_text <BMP-file>" << endl;
		return 1;
	}
	string filename = argv[1];
	BMP img;
	img.ReadFromFile(filename.c_str());
	int width = img.TellWidth();
	int height = img.TellHeight();
	
	BMP out;
	out.SetSize(width,height);
	
	bool peakArray[width];
	bool last_was_peak = false;
	for(int x = 0; x < width; x++)
	{
		double pixel_sum = 0;
		double max_value = 255;
		bool peak = false;
		for(int y = 0; y < height; y++)
		{
			out(x,y)->Red = img(x,y)->Red;
			out(x,y)->Green = img(x,y)->Green;
			out(x,y)->Blue = img(x,y)->Blue;
			double color_avg = (img(x,y)->Red + img(x,y)->Green + img(x,y)->Blue)/3.0;
			pixel_sum += color_avg;
			if(max_value > color_avg)
			{
				max_value = color_avg;
			}
		}
		double avg_color = pixel_sum/(double)height;
		double lightcondition_weight = avg_color/190.0;
		if(avg_color - max_value > 25*lightcondition_weight)
		{
			peak = true;
			peakArray[x] = true;
		}
		else
		{
			peakArray[x] = false;
			for(int y = 0; y < height; y++)
			{
				out(x,y)->Red = 0;
				out(x,y)->Green = 0;
				out(x,y)->Blue = 0;
			}
		}
	}
	
	out.WriteToFile("splitted_aligned.bmp");
	
	int character_count = 1;
	for(int x = 0; x < width; x++)
	{
		int character_width = 0;
		while(x+character_width+1 < width && peakArray[x+character_width])
		{
			character_width++;
		}
		if(character_width <= 1)
		{
			cout << " ";
			continue;
		}
		BMP character_image;
		character_image.SetSize(character_width,height);
		for(int x2 = x; x2 < x+character_width; x2++)
		{
			for(int y = 0; y < height; y++)
			{
				character_image(x2-x,y)->Red = out(x2,y)->Red;
				character_image(x2-x,y)->Green = out(x2,y)->Green;
				character_image(x2-x,y)->Blue = out(x2,y)->Blue;
			}
		}
		stringstream ss;
		ss << "Character_" << character_count << ".bmp";
		string character_image_filename;
		ss >> character_image_filename;
		character_image.WriteToFile(character_image_filename.c_str());
		bw_char(character_image_filename);
		character_count++;
		x += character_width;
	}
	cout << endl;

	return 0;
}

